package com.zhongzheng.modules.order.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.order.bo.OrderActivityAddBo;
import com.zhongzheng.modules.order.bo.OrderActivityQueryBo;
import com.zhongzheng.modules.order.bo.OrderActivityEditBo;
import com.zhongzheng.modules.order.domain.OrderActivity;
import com.zhongzheng.modules.order.mapper.OrderActivityMapper;
import com.zhongzheng.modules.order.vo.OrderActivityVo;
import com.zhongzheng.modules.order.service.IOrderActivityService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 活动订单Service业务层处理
 *
 * @author ruoyi
 * @date 2021-07-01
 */
@Service
public class OrderActivityServiceImpl extends ServiceImpl<OrderActivityMapper, OrderActivity> implements IOrderActivityService {

    @Override
    public OrderActivityVo queryById(Long id){
        OrderActivity db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, OrderActivityVo.class);
    }

    @Override
    public List<OrderActivityVo> queryList(OrderActivityQueryBo bo) {
        LambdaQueryWrapper<OrderActivity> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getOrderSn() != null, OrderActivity::getOrderSn, bo.getOrderSn());
        lqw.eq(bo.getActivityId() != null, OrderActivity::getActivityId, bo.getActivityId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<OrderActivityVo> entity2Vo(Collection<OrderActivity> collection) {
        List<OrderActivityVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, OrderActivityVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<OrderActivity> page = (Page<OrderActivity>)collection;
            Page<OrderActivityVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(OrderActivityAddBo bo) {
        OrderActivity add = BeanUtil.toBean(bo, OrderActivity.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(OrderActivityEditBo bo) {
        OrderActivity update = BeanUtil.toBean(bo, OrderActivity.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(OrderActivity entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
